'here I generate exact and log 1-year returns
smpl @all
genr ret_1=((p+div)/p(-1))-1
genr div_gr_1=(div-div(-1))/div(-1)
genr ln_return=log(1+ret_1)
genr ln_divgr_1=log(1+ln_divgr_1)
genr infl=(cpi-cpi(-1))/cpi(-1)
genr infl_l=log(cpi/cpi(-1))
genr ret_1_r=1+ret_1-infl_l
genr div_gr_1_r=log(1+div_gr_1)-infl_l
'2-year annualized returns
genr ret_2_r=(ret_1_r+ret_1_r(-1))/2
genr div_gr_2_r=(div_gr_1_r+div_gr_1_r(-1))/2
'3-year annualized returns
genr ret_3_r=(ret_1_r+ret_1_r(-1)+ ret_1_r(-2))/3
genr div_gr_3_r=(div_gr_1_r+div_gr_1_r(-1)+div_gr_1_r(-2))/3
'4-year annualized returns
genr ret_4_r=(ret_1_r+ret_1_r(-1)+ ret_1_r(-2)+ ret_1_r(-3))/4
genr div_gr_4_r=(div_gr_1_r+div_gr_1_r(-1)+div_gr_1_r(-2)+div_gr_1_r(-3))/4
'5-year annualized returns
genr ret_5_r=(ret_1_r+ret_1_r(-1)+ ret_1_r(-2)+ ret_1_r(-3)+ret_1_r(-4))/5
genr div_gr_5_r=(div_gr_1_r+div_gr_1_r(-1)+div_gr_1_r(-2)+div_gr_1_r(-3)+div_gr_1_r(-4) )/5
'6-year annualized returns
genr ret_6_r=(ret_1_r+ret_1_r(-1)+ ret_1_r(-2)+ ret_1_r(-3)+ret_1_r(-4)+ret_1_r(-5))/6
genr div_gr_6_r=(div_gr_1_r+div_gr_1_r(-1)+div_gr_1_r(-2)+div_gr_1_r(-3)+div_gr_1_r(-4)+div_gr_1_r(-5) )/6

'exact returns
smpl 1900 1900
genr ccap=1
genr cp=1
smpl 1901 2008
series ccap=ccap(-1)*(1+ret)
series cp=cp(-1)*(1+infl)
series cret=ccap-1
series cinfl=cp-1
series cret_r=((1+cret)/(1+cinfl))-1
genr ccap_r=1+cret_r
smpl 1910 2008
'1-year annualized exact returns 
genr ret_01y=(ccap-ccap(-1))/ccap(-1)
genr infl_01y=(cp-cp(-1))/cp(-1)
genr ret_01y_ann=(1+ret_01y)-1
genr ret_01y_ann_r=((1+ret_01y)/(1+infl_01y))-1
genr div_gr01y=(div-div(-1))/div(-1)
genr div_gr01y_ann_r=((1+div_gr01y)/(1+infl_01y))-1
'2-year annualized exact returns 
genr ret_02y=(ccap-ccap(-2))/ccap(-2)
genr infl_02y=(cp-cp(-2))/cp(-2)
genr ret_02y_ann=((1+ret_02y)^(1/2))-1
genr ret_02y_ann_r=(((1+ret_02y)/(1+infl_02y))^(1/2))-1
genr div_gr02y=(div-div(-2))/div(-2)
genr div_gr02y_ann_r=(((1+div_gr02y)/(1+infl_02y))^(1/2))-1
'3-year annualized exact returns 
genr ret_03y=(ccap-ccap(-3))/ccap(-3)
genr infl_03y=(cp-cp(-3))/cp(-3)
genr ret_03y_ann=((1+ret_03y)^(1/3))-1
genr ret_03y_ann_r=(((1+ret_03y)/(1+infl_03y))^(1/3))-1
genr div_gr03y=(div-div(-3))/div(-3)
genr div_gr03y_ann_r=(((1+div_gr03y)/(1+infl_03y))^(1/3))-1
'4-year annualized exact returns 
genr ret_04y=(ccap-ccap(-4))/ccap(-4)
genr infl_04y=(cp-cp(-4))/cp(-4)
genr ret_04y_ann=((1+ret_04y)^(1/4))-1
genr ret_04y_ann_r=(((1+ret_04y)/(1+infl_04y))^(1/4))-1
genr div_gr04y=(div-div(-4))/div(-4)
genr div_gr04y_ann_r=(((1+div_gr04y)/(1+infl_04y))^0.25)-1
'5-year annualized exact returns
genr ret_05y=(ccap-ccap(-5))/ccap(-5)
genr infl_05y=(cp-cp(-5))/cp(-5)
genr ret_05y_ann=((1+ret_05y)^0.2)-1
genr ret_05y_ann_r=(((1+ret_05y)/(1+infl_05y))^0.2)-1
genr div_gr05y=(div-div(-5))/div(-5)
genr div_gr05y_ann_r=(((1+div_gr05y)/(1+infl_05y))^0.2)-1
'6-year annualized exact returns
genr ret_06y=(ccap-ccap(-6))/ccap(-6)
genr infl_06y=(cp-cp(-6))/cp(-6)
genr ret_06y_ann=((1+ret_06y)^(1/6))-1
genr ret_06y_ann_r=(((1+ret_06y)/(1+infl_06y))^(1/6))-1
genr div_gr06y=(div-div(-6))/div(-6)
genr div_gr06y_ann_r=(((1+div_gr06y)/(1+infl_06y))^(1/6))-1
'10-year annualized exact returns
genr ret_10y=(ccap-ccap(-10))/ccap(-10)
genr infl_10y=(cp-cp(-10))/cp(-10)
genr ret_10y_ann=((1+ret_10y)^0.1)-1
genr ret_10y_ann_r=(((1+ret_10y)/(1+infl_10y))^0.1)-1
genr div_gr10y=(div-div(-10))/div(-10)
genr div_gr10y_ann_r=(((1+div_gr10y)/(1+infl_10y))^0.1)-1
'20-year annualized exact returns
smpl 1920 2008
genr ret_20y=(ccap-ccap(-20))/ccap(-20)
genr infl_20y=(cp-cp(-20))/cp(-20)
genr ret_20y_ann=((1+ret_20y)^0.05)-1
genr ret_20y_ann_r=(((1+ret_20y)/(1+infl_20y))^0.05)-1
genr div_gr20y=(div-div(-20))/div(-20)
genr div_gr20y_r=((1+div_gr20y)/(1+infl_20y))-1

'genr gdp_gr05y= (gdpca-gdpca(-5))/gdpca(-5)
'genr gdp_gr10y= (gdpca-gdpca(-10))/gdpca(-10)
'genr gdp_gr20y= (gdpca-gdpca(-20))/gdpca(-20)

smpl 1920 2050
genr MY_RS=my*(@mean(ret_20y_ann,"1920 2008")/@mean(my,"1920 2008"))
delete fig_* graph*
graph fig_3.line(x) MY ret_20y_ann_r
fig_3.name(1) Middle (40 to 49)-to-Young(20 to 29) ratio (left scale)
fig_3.name(2) 20-Year annualized real US Stock Market Returns (right scale)
fig_3.axis grid zeroline
fig_3.setelem(1) lcolor(blue) lwidth(1) lpat(1)
fig_3.setelem(2) lcolor(red) lwidth(1) lpat(1)
fig_3.draw(shade,bottom) 2008 2050
smpl 1900 2010
graph graph_fgt1.line CCAP_R
graph_fgt1.name(1) real value of 1 USD invested in  1900
'graph_fgt1.name(2) 20-Year annualized US Stock Market Returns (right scale)
graph_fgt1.axis grid zeroline
graph_fgt1.setelem(1) lcolor(blue) lwidth(1) lpat(1)
'graph_fgt1.setelem(2) lcolor(red) lwidth(1) lpat(1)
'graph_fgt1.draw(shade,bottom) 2008 2050
smpl 1920 2010
graph graph_fgt2.line(x) RET_20Y_Ann_r
graph_fgt2.name(1) 20-Year annualized real US Stock Market Returns 
'graph_fgt1.name(2) 20-Year annualized US Stock Market Returns (right scale)
graph_fgt2.axis grid zeroline
graph_fgt2.setelem(1) lcolor(blue) lwidth(1) lpat(1)
'graph_fgt1.setelem(2) lcolor(red) lwidth(1) lpat(1)
'graph_fgt1.draw(shade,bottom) 2008 2050

'---------------------------------------------------------------------------------------------------
smpl @all
series temp1
series temp2
series temp3
smpl 1909 1954
genr temp1=@mean(ldp,"1909 1954")
smpl 1955 1994
temp2=@mean(ldp,"1955 1994")
smpl 1995 2008
temp3=@mean(ldp,"1995 2008")

smpl 1909 2008
graph fig_1.line ldp temp1 temp2 temp3

fig_1.option linepat	' need to set linepat
fig_1.setelem(1) lcolor(blue) lwidth(2) lpat(solid)' symbol(2)
fig_1.setelem(2) lcolor(red) lwidth(2) lpat(dash1)
fig_1.setelem(3) lcolor(green) lwidth(2) lpat(dash1)
fig_1.setelem(4) lcolor(black) lwidth(2) lpat(dash1)

fig_1.axis grid zeroline
fig_1.draw(solidline, bottom, color(blue), width(2)) 1954
fig_1.draw(solidline, bottom, color(blue), width(2)) 1994

fig_1.name(1) d-p
fig_1.name(2) 
fig_1.name(3) 
fig_1.name(4)

