delete Table*
'Cointegration test of dividend and price
smpl 1911 2008
var veclpd.ls 1 1 LP LD @ c
freeze(table_cointlpd_full) veclpd.coint(c,1) 
veclpd.cleartext(coint)
veclpd.append(coint)  B(1,1)=-1, B(1,2)=1
veclpd.ec(c,1,restrict,m=5000) 1 1 LP LD @ c
freeze(table_cointlpd_full_rest) veclpd
freeze(table_uroot_full) ldp.uroot
smpl 1955 2008
veclpd.ls 1 2 LP LD @ c
freeze(table_cointlpd_pw) veclpd.coint(c,1) 
veclpd.cleartext(coint)
veclpd.append(coint)  B(1,1)=-1, B(1,2)=1
var veclpd.ec(c,1,restrict,m=5000) 1 1 LP LD @ c
freeze(table_cointlpd_pw_rest) veclpd
freeze(table_uroot_pw) ldp.uroot

'Cointegration test of dividend and price and MY
smpl 1911 2008
var vecall_notfp.ls 1 1 LP LD MY @ c
freeze(table_vecall_notfp_full) vecall_notfp.coint(c,1) 

'testing restrictions
vecall_notfp.cleartext(coint)
vecall_notfp.append(coint)  B(1,1)=-1
vecall_notfp.ec(c,1,restrict,m=5000) 1 1 LP LD  MY  @ c
freeze(table_vecall_notfp_full_rest) vecall_notfp

smpl 1955 2008
freeze(table_vecall_notfp_pw) vecall_notfp.coint(c,1) 

'testing restrictions
vecall_notfp.cleartext(coint)
vecall_notfp.append(coint)  B(1,1)=-1
vecall_notfp.ec(c,1,restrict,m=5000) 1 1 LP LD  MY  @ c
freeze(table_vecall_notfp_pw_rest) vecall_notfp

'*******************************************************************
'*******************************************************************
'graphs

smpl 1909 2008
vecall_notfp.ec(c,1,restrict,m=5000) 1 1 LP LD  MY  @ c

genr LDP_ADJ_notfp=vecall_notfp.B(1,1)*LP + vecall_notfp.B(1,2)*LD + vecall_notfp.B(1,3)*MY +vecall_notfp.b(1,4)
genr ldp_dem=ldp-@mean(ldp)

smpl 1909 2008
delete fig_2a*
graph fig_2a.line ldp_dem ldp_dt ldp_adj_notfp  ldp_lvn
fig_2a.option linepat	' need to set linepat
fig_2a.setelem(1) lcolor(blue) lwidth(2) lpat(solid)' symbol(2)
fig_2a.setelem(2) lcolor(red) lwidth(2) lpat(dash1)
fig_2a.setelem(3) lcolor(green) lwidth(2) lpat(dash8)
fig_2a.setelem(4) lcolor(black) lwidth(2) lpat(dash2)

fig_2a.axis grid zeroline
fig_2a.draw(solidline, bottom, color(blue), width(2)) 1954
fig_2a.draw(solidline, bottom, color(blue), width(2)) 1991
fig_2a.name(1) d-p
fig_2a.name(2) d-p adjusted for TFP and MY
fig_2a.name(3) d-p adjusted for MY only
fig_2a.name(4) d-p adjusted for breaks (L&VN)

